import pygame

pygame.init()
win = pygame.display.set_mode((500, 480))

# Niz walkRight sadrzi slike u kojima se karakter krece u pravcu desno
walkRight = [pygame.image.load('animacija_sprajtova/Right1.png'), pygame.image.load('animacija_sprajtova/Right2.png'), pygame.image.load('animacija_sprajtova/Right3.png'),
             pygame.image.load('animacija_sprajtova/Right4.png'), pygame.image.load('animacija_sprajtova/Right5.png'), pygame.image.load('animacija_sprajtova/Right6.png'),
             pygame.image.load('animacija_sprajtova/Right7.png'), pygame.image.load('animacija_sprajtova/Right8.png'), pygame.image.load('animacija_sprajtova/Right9.png')]
# Niz walkLeft sadrzi slike u kojima se karakter krece u pravcu levo
walkLeft = [pygame.image.load('animacija_sprajtova/Left1.png'), pygame.image.load('animacija_sprajtova/Left2.png'), pygame.image.load('animacija_sprajtova/Left3.png'),
            pygame.image.load('animacija_sprajtova/Left4.png'), pygame.image.load('animacija_sprajtova/Left5.png'), pygame.image.load('animacija_sprajtova/Left6.png'),
            pygame.image.load('animacija_sprajtova/Left7.png'), pygame.image.load('animacija_sprajtova/Left8.png'), pygame.image.load('animacija_sprajtova/Left9.png')]
# Slike pozadine i karaktera koji stoji
bg = pygame.image.load('animacija_sprajtova/bg.jpg')
char = pygame.image.load('animacija_sprajtova/standing.png')

x = 50          # (x,y) - pocetna pozicija karaktera
y = 400
width = 40      # (sirina, visina) - sirina i visina karaktera
height = 60
vel = 5         # vel - "brzina" karaktera - karakter se pomera 5 piksela od trenutne pozicije

clock = pygame.time.Clock()

# Promenljive za pracenje kretanja karaktera na osnovu onoga sto korisnik pritisne na tastaturi
left = False    # Ako taster sa strelicom LEVO pritisnut, promenljiva left će biti True
right = False   # Ako taster sa strelicom DESNO pritisnut, promenljiva right će biti True
walkCount = 0   # Promenljiva koja "prati" koliko puta je taster pritisnut

# --------------------------------------------------
def Animation_Logic():
    """ Promenljiva walkCount je deklarisana u glavnoj petlji 
    i broji koliko puta je korisnik pritisnuo bilo koji taster. 
    Da bi se menjala njena vrednost mora da bude uvedena kao globalna promenljiva u funkciji. """
    global walkCount

    """ blit kao prvi argument dobija sprajt koji treba da se renderuje,
    a kao drugi argument dobija koordinate pozicije na kojoj treba da bude prikazan """
    win.blit(bg, (0, 0))
    if walkCount + 1 >= 27:
        walkCount = 0

    """ odredjuje karakter koji treba da bude prikazan kada god se dostignu ekstremne pozicije. 
    Vrsi se izbor odgovarajuce poze ili se prikazuje karakter kako stoji u mestu """
    if left:
        win.blit(walkLeft[walkCount // 3], (x, y))
        walkCount += 1
    elif right:
        win.blit(walkRight[walkCount // 3], (x, y))
        walkCount += 1
    else:
        win.blit(char, (x, y))
        walkCount = 0

    pygame.display.update()
# --------------------------------------------------
""" Glavna petlja rukuje obradom korisnickih dogadjaja, 
odnosno sta se radi kada korisnik pritisne taster LEVO ili DESNO
i kreira se logika animacije koja odredjuje koja slika se prosledjuje
blit funkciji u kom trenutku na osnovu korisnickih dogadjaja. """
finish = False

# Beskonacna petlja gde se definise Frame per second upotrebom tick metoda
while not finish:
    
    """ zapocinje rukovanje kriticnim korisnickim dogadjajima. 
    U jednostavnim animacijama sprite-ova, rukuje se sa osnovna pokreta: LEVO i DESNO: """
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            finish = True

    keys = pygame.key.get_pressed()

    # provera da li je pritisnut taster za levo  i da li je karakter na x (granici) ili ne
    if keys[pygame.K_LEFT] and x > vel:
        x -= vel # pomera se ulevo za 5 piksela
        left = True
        right = False
    # provera da li je pritisnut taster za desno i da li se karakter poklapa sa desnom granicom
    elif keys[pygame.K_RIGHT] and x < 500 - vel - width:
        x += vel # pomera se udesno za 5 piksela
        left = False
        right = True

    else:
        # nije pritisnut ni jedan taster levo ili desno
        left = False
        right = False
        walkCount = 0
    """ Metod koji je centralni blok koda za iscrtavanje igrice koja prikazuje slike ili sprite-ove
    u njemu ce se renderovati (pozivom metoda blit) slike koje prikazuju kretanje karaktera koji stoji
    krece se levo ili desno, kao i pozadine, a potom ce se na osnovu dogadjaja korisnika, ponovo iscrtavati prozor
    igrice sa odgovarajucim prikazom slike izabrane iz niza renderovanih slika """
    Animation_Logic()

    clock.tick(27)  # ovaj metod se poziva po jednom za svaki frejm
                    # i izracunava koliko je milisekundi proteklo od prethodnog poziva

pygame.quit()
